;To assemble:
;  nasm 0index.asm -o bbw.bin
;______________________________________________________________________________


;Index file
;______________________________________________________________________________

;Memory map:
; 0x00000000 to 0x000004FF = reserved for BIOS (IVT and BIOS Data Area)
; 0x00000500 to 0x00000FFF = used for stack space (2.75 KiB)
; 0x00001000 to 0x00001FFF = used for BIOS wrapper code and data (4 KiB)
; 0x00007000 to EBDA = unused (reserved for boot loader, etc)

%define START_ADDRESS		0x00001000

	org START_ADDRESS

;Binary header
;______________________________________________________________________________

	dd END-$$									;0x00000000 = size of binary in bytes
	jmp 0x0000:START							;0x00000004 = real mode entry point

	times ($$-$+0x010) nop

exceptionHandlerAddress:	dd genericExceptionHandler	;0x00000010 = address of exception handler
tempExceptionNumber:	dd 0						;0x00000014 = exception number for exception
tempErrorCode:			dd 0						;0x00000018 = error code for exception
tempEAX:				dd 0						;0x0000001C = contents of EAX for exception
tempEBX:				dd 0						;0x00000020 = contents of EBX for exception
tempECX:				dd 0						;0x00000024 = contents of ECX for exception
tempEDX:				dd 0						;0x00000028 = contents of EDX for exception
tempESI:				dd 0						;0x0000002C = contents of ESI for exception
tempEDI:				dd 0						;0x00000030 = contents of EDI for exception
tempEBP:				dd 0						;0x00000034 = contents of EBP for exception
tempSS:				dd 0						;0x00000038 = contents of SS for exception
tempESP:				dd 0						;0x0000003C = contents of ESP for exception
tempCS:				dd 0						;0x00000040 = contents of CS for exception
tempEIP:				dd 0						;0x00000044 = contents of EIP for exception
tempDS:				dd 0						;0x00000048 = contents of DS for exception
tempES:				dd 0						;0x0000004C = contents of ES for exception
tempEFLAGS:			dd 0						;0x00000050 = contents of EFLAGS for exception
tempCR2:				dd 0						;0x00000054 = contents of CR2 for exception


;Source code
;______________________________________________________________________________

	%include "init.asm"
	%include "int.asm"
	%include "except.asm"
	%include "data.asm"

	align 4
END:
