;Initialisation
;______________________________________________________________________________

;Input
; edi	Address of 32-bit code to jump to

START:
	xor ax,ax
	mov ds,ax
;	mov es,ax
	cli
	mov ss,ax						;ss = data selector for protected mode
     mov esp,START_ADDRESS
	sti

;Create IDT

	mov eax,0x0018 << 16			;eax = code selector for all IDT entries << 16
	mov ebx,(0x0000 << 16) + 0x8E00	;ebx = attributes (present, DPL=0, 32-bit interrupt gate) and offset high 16-bits
	xor ecx,ecx
.nextIDT:
	mov ax,[IDTdata+ecx*2]			;ax = offset low 16-bits
	mov [END+ecx*8],eax				;Set attributes (present, DPL=0, 32-bit interrupt gate) and offset high 16-bits
	mov [END+ecx*8+4],ebx			;Set offset low 16-bits and segment selector
	inc cl
	test cl,32
	je .nextIDT


;Switch to protected mode

	mov eax,cr0					;eax = cr0
	lgdt [cs:GDT]					;Load GDT
	or al,1						;eax = cr0 with protected mode enable flag set
	mov bx,0x0020					;bx = data selector for protected mode
	xor cx,cx						;cx = null selector for protected mode

	cli							;Disable IRQs
	lidt [NULL_IDT]				;Load "NULL IDT" to ensure NMI causes triple fault

	mov cr0,eax					;Enable protected mode
	jmp .here1					;Flush pipeline on old CPUs
.here1:
	jmp 0x0018:.here2				;Load CS and switch to 32-bit
.here2:
	bits 32

	mov ds,bx						;ds = data selector for protected mode
	mov es,bx						;es = data selector for protected mode
	mov ss,bx						;ss = data selector for protected mode
     mov esp,START_ADDRESS			;ss:esp = top of stack (just below BBW code)
	mov fs,cx						;fs = null selector (unused)
	mov gs,cx						;gs = null selector (unused)

	lidt [BBW_IDT]					;Load protected mode IDT

	jmp edi
